import es, playerlib, popuplib

# BEGIN CONFIG
colors_command = '!colors'
enable_invisible = 0 # Enables players to use invisible color - 0 = Off, 1 = On
# END CONFIG

dict_color = {}

# Addon Info
info = es.AddonInfo()
info.name           = "Crazy Colors"
info.basename       = "crazy_colors"
info.version        = "1.3b"
info.author         = "Undead"
info.collaborator   = "101satoon101"
info.url            = "http://forums.mattie.info/cs/forums/viewtopic.php?t=25168"
info.description    = "Fun Script that allows players to change their color"

es.ServerVar(info.basename, info.version, info.description).makepublic()

colordict = {}
colordict['Normal'] = {'red':255,'green':255,'blue':255}
colordict['Invisible'] = {'red':0,'green':0,'blue':0}
colordict['Green'] = {'red':0,'green':128,'blue':0}
colordict['Orange'] = {'red':255,'green':128,'blue':0}
colordict['Purple'] = {'red':128,'green':0,'blue':128}
colordict['Blue'] = {'red':0,'green':0,'blue':255}
colordict['Red'] = {'red':255,'green':0,'blue':0}
colordict['Black'] = {'red':0,'green':0,'blue':64}
colordict['Yellow'] = {'red':255,'green':255,'blue':0}
colordict['Light Blue'] = {'red':0,'green':255,'blue':255}
colordict['Pink'] = {'red':255,'green':0,'blue':128}
colordict['Brown'] = {'red':128,'green':64,'blue':0}
colordict['Grey'] = {'red':192,'green':192,'blue':192}
colordict['Lime'] = {'red':128,'green':255,'blue':0}
colordict['Navy'] = {'red':0,'green':0,'blue':160}
colordict['Peach'] = {'red':255,'green':128,'blue':128}
colordict['Maroon'] = {'red':128,'green':0,'blue':0}

def load():
    # Register !colors command
    if not es.exists('saycommand', 'colors_command'):
        es.regsaycmd(colors_command, 'crazy_colors/colors_menu')
    # Create Colors Popup Menu in Memory
    colors = popuplib.easymenu('colors', '_popup_choice', _select_color)
    colors.settitle("Select a Color:")
    for color in colordict:
        if enable_invisible == 1 or color != 'Invisible':
            colors.addoption(color, color)
    es.msg('#multi', '#green[Crazy Colors] #defaultby #lightgreenUndead #defaulthas been loaded!')
    for user in es.getUseridList('#human'):
        default(user)

# Colors Menu
def _select_color(userid, choice, name):
    global dict_color
    user = playerlib.getPlayer(userid)
    dict_color[user] = {}
    dict_color[user]["color"] = choice
    changecolor(user)

# Send Colors Menu to Command User
def colors_menu():
    popuplib.send('colors', es.getcmduserid())

def player_activate(ev):
    global dict_color
    user = ev['userid']
    if ev['es_steamid'] != 'BOT':
        default(user)

def default(user):
    gamethread.delayed(2.5, es.tell(user, "This Server is running Crazy Colors. The Command is: %s" %colors_command))
    dict_color[user] = {}
    dict_color[user]["color"] = 'Normal'

def player_disconnect(ev):
    global dict_color
    user = ev['userid']
    if user in dict_color:
        del dict_color[user]

def player_spawn(ev):
    global dict_color
    user = playerlib.getPlayer(ev['userid'])
    if user in dict_color:
        changecolor(user)

def changecolor(user):
    color = dict_color[user]["color"]
    if color == 'Invisible':
        user.set("color", [0, 0, 0, 0])
    else:
        red = colordict[color]['red']
        green = colordict[color]['green']
        blue = colordict[color]['blue']
        user.set("color", [red, green, blue])

def unload():
    # Unregister !colors command
    if es.exists('saycommand', colors_command):
        es.unregsaycmd(colors_command)
    # Delete Colors Popup Menu from Memory
    popuplib.delete('colors')
    es.msg('#multi', '#green[Crazy Colors] #defaultby #lightgreenUndead #defaulthas been unloaded!')